// ◇UTF-8
// cloudappdata: Google Drive Cloud App Data Tester
// Copyright (C)2013 GORRY.

package net.gorry.com.example.cloudappdata;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;

import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.TextView;
import android.widget.ViewSwitcher;

import net.gorry.com.example.cloudappdata.nogms.R;

/**
 * 
 * GoogleからOAuth2認証を取得する
 *
 * @author gorry
 * 
 */
public class OAuth2GoogleActivity extends Activity {
	private static final boolean RELEASE = true;
	private static final String TAG = "myGoogleCloudAppdata";
	private static final boolean VV = false;
	private static final boolean V = false;
	private static final boolean D = false;
	private static final boolean I = !RELEASE;

	private static String M() {
		StackTraceElement[] es = new Exception().getStackTrace();
		int count = 1; while (es[count].getMethodName().contains("$")) count++;
		return es[count].getFileName()+"("+es[count].getLineNumber()+"): "+es[count].getMethodName()+"()";
	}

	public static final String CLIENT_ID = "ClientId";
	public static final String CLIENT_SECRET = "ClientSecret";
	public static final String SCOPE = "Scope";
	public static final String ACCESS_TOKEN = "AccessToken";
	public static final String REFRESH_TOKEN = "RefreshToken";

	private String mClientId;
	private String mClientSecret;
	private String mScope;
	private String mRefreshToken;

	private ViewSwitcher mViewSwitcher;
	private TextView mTextProgressMessage;
	private WebView mWebView;


	@SuppressLint("SetJavaScriptEnabled")
	@Override
	public void onCreate(Bundle savedInstanceState) {
		if (VV) Log.v(TAG, M()+": start");

		super.onCreate(savedInstanceState);
		setContentView(R.layout.activityoauth2google);

		Intent intent = getIntent();
		mClientId = intent.getStringExtra(CLIENT_ID);
		mClientSecret = intent.getStringExtra(CLIENT_SECRET);
		mScope = intent.getStringExtra(SCOPE);

		mViewSwitcher = (ViewSwitcher)findViewById(R.id.viewSwitcher);
		mTextProgressMessage = (TextView)findViewById(R.id.textProgressMessage);
		mWebView = (WebView)findViewById(R.id.webView);

		mWebView.getSettings().setJavaScriptEnabled(true);
		mWebView.setWebViewClient(new myWebViewClient());

		try {
			String url = "https://accounts.google.com/o/oauth2/auth"
			  + "?client_id=" + mClientId
			  + "&response_type=code"
			  + "&redirect_uri=urn:ietf:wg:oauth:2.0:oob"
			  + "&scope=" + URLEncoder.encode(mScope, "UTF-8");
			if (I) Log.i(TAG, M()+": access to ["+url+"]");
			mWebView.loadUrl(url);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}

		if (VV) Log.v(TAG, M()+": end");
	}

	private class myWebViewClient extends WebViewClient {
		@TargetApi(Build.VERSION_CODES.HONEYCOMB)
		@Override
		public void onPageFinished(WebView view, String url) {
			if (VV) Log.v(TAG, M()+": start: url=["+url+"]");

			String title = view.getTitle();
			String code = getCode(title);

			if (code == null) {
				if (I) Log.i(TAG, M()+": not finished");
				if (!(mViewSwitcher.getCurrentView() instanceof WebView)) {
					mViewSwitcher.showNext();
				}
				if (VV) Log.v(TAG, M()+": end: try next");
				return;
			}

			if (I) Log.i(TAG, M()+": finished: code=["+code+"]");
			mViewSwitcher.showPrevious();
			AsyncTask<String, ?, ?> a = new TaskGetAccessToken();
			if (Build.VERSION.SDK_INT < 13) {
				a.execute(code);
			} else {
				a.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, code);
			}

			if (VV) Log.v(TAG, M()+": end: start get token");
		}
	}

	private String getCode(String title) {
		if (VV) Log.v(TAG, M()+": start");

		String code = null;
		String codeKey = "code=";
		int idx = title.indexOf(codeKey);
		if (idx < 0) {
			if (VV) Log.v(TAG, M()+": end: no code");
			return null;
		}
		code = title.substring(idx + codeKey.length());

		if (VV) Log.v(TAG, M()+": end: code=["+code+"]");
		return code;
	}

	private class TaskGetAccessToken extends AsyncTask<String, Void, String> {

		@Override
		public void onPreExecute() {
			if (VV) Log.v(TAG, M()+": start");
			mTextProgressMessage.setText(R.string.oauth2_text_gettingtoken);
			if (VV) Log.v(TAG, M()+": end");
		}


		@Override
		public String doInBackground(String... codes) {
			if (VV) Log.v(TAG, M()+": start");

			String token = null;
			mRefreshToken = null;
			DefaultHttpClient client = new DefaultHttpClient();

			try {
				ArrayList<NameValuePair> form = new ArrayList<NameValuePair>();
				form.add(new BasicNameValuePair("code", codes[0]));
				form.add(new BasicNameValuePair("client_id", mClientId));
				form.add(new BasicNameValuePair("client_secret", mClientSecret));
				form.add(new BasicNameValuePair("redirect_uri", "urn:ietf:wg:oauth:2.0:oob"));
				form.add(new BasicNameValuePair("grant_type", "authorization_code"));

				HttpPost post = new HttpPost("https://accounts.google.com/o/oauth2/token");
				post.setEntity(new UrlEncodedFormEntity(form, "UTF-8"));
				if (I) Log.i(TAG, M()+": execute: post=["+post+"]");
				HttpResponse response = client.execute(post);
				HttpEntity entity = response.getEntity();
				String result = EntityUtils.toString(entity);
				if (I) Log.i(TAG, M()+": result=["+result+"]");

				JSONObject json = new JSONObject(result);
				if (json.has("access_token")) {
					token = json.getString("access_token");
					if (json.has("refresh_token")) {
						mRefreshToken = json.getString("refresh_token");
					}
					if (I) Log.i(TAG, M()+": access_token=["+token+"], refresh_token=["+mRefreshToken+"]");
				} else {
					if (json.has("error")) {
						String error = json.getString("error");
						if (I) Log.i(TAG, M()+": error=["+error+"]");
					} else {
						Log.e(TAG, M()+": undefined");
					}
				}

			} catch (ClientProtocolException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (JSONException e) {
				e.printStackTrace();
			} finally {
				client.getConnectionManager().shutdown();
			}

			if (VV) Log.v(TAG, M()+": end: token=["+token+"]");
			return token;
		}

		@Override
		public void onPostExecute(String token) {
			if (VV) Log.v(TAG, M()+": start: token=["+token+"]");

			if (token == null) {
				Log.e(TAG, M()+": failed: cannot get token");
				Intent intent = new Intent();
				setResult(Activity.RESULT_CANCELED, intent);
				finish();
			}

			if (I) Log.i(TAG, M()+": get token=["+token+"]");
			Intent intent = new Intent();
			intent.putExtra(ACCESS_TOKEN, token);
			if (mRefreshToken != null) {
				intent.putExtra(REFRESH_TOKEN, mRefreshToken);
			}
			setResult(Activity.RESULT_OK, intent);
			finish();
		}

	}


}
